@echo off
rem --- 'zz4_sm_collect_multi-release.cmd' v2.6 by KdL (2020.01.09)

set TIMEOUT=1
set PROJECT=ocm_sm
set SRC=C:\Altera\multi-release\
set DEST=..\firmware\
if "%1"=="" color 1f&title Multi-Release collector tool for SM-X
if not exist "%QUARTUS_ROOTDIR%\common\devinfo\cycloneive" goto err_quartus
if not exist %SRC% goto err_msg
if "%1"=="" echo.&echo WARNING: the '%DEST%' folder will be updated!
if "%1"=="" echo.&echo Press any key to proceed...&pause >nul
cls&if "%1"=="" echo.&echo Please wait...
rem ---------------cleanup----------------
rd /S /Q %DEST%\smx_br_layout >nul 2>nul
rd /S /Q %DEST%\smx_es_layout >nul 2>nul
rd /S /Q %DEST%\smx_fr_layout >nul 2>nul
rd /S /Q %DEST%\smx_jp_layout >nul 2>nul
rd /S /Q %DEST%\smx_us_layout >nul 2>nul
rem --------------------------------------
if not exist %PROJECT%.qsf.area.off set OPTMODE=1
if not exist %PROJECT%.qsf.area.normal if "%OPTMODE%"=="" (set OPTMODE=2) else (set OPTMODE=0)
if not exist %PROJECT%.qsf.area.extraeffort if "%OPTMODE%"=="" (set OPTMODE=3) else (set OPTMODE=0)
if not exist %PROJECT%.qsf.balanced.off if "%OPTMODE%"=="" (set OPTMODE=4) else (set OPTMODE=0)
if not exist %PROJECT%.qsf.balanced.normal if "%OPTMODE%"=="" (set OPTMODE=5) else (set OPTMODE=0)
if not exist %PROJECT%.qsf.balanced.extraeffort if "%OPTMODE%"=="" (set OPTMODE=6) else (set OPTMODE=0)
if "%OPTMODE%"=="0" set OPTMODE=(unknown_optimization)
if "%OPTMODE%"=="1" set OPTMODE=(area_powerplay_off)
if "%OPTMODE%"=="2" set OPTMODE=(area_normal_compilation)
if "%OPTMODE%"=="3" set OPTMODE=(area_extra_effort)
if "%OPTMODE%"=="4" set OPTMODE=(balanced_powerplay_off)
if "%OPTMODE%"=="5" set OPTMODE=(balanced_normal_compilation)
if "%OPTMODE%"=="6" set OPTMODE=(balanced_extra_effort)
set YENSLASH=backslash
set LAYOUT=br
call :collect_smx
set LAYOUT=es
call :collect_smx
set LAYOUT=fr
call :collect_smx
set LAYOUT=us
call :collect_smx
set YENSLASH=yen
set LAYOUT=jp
call :collect_smx
rem ---------------cleanup----------------
rd /S /Q %SRC% >nul 2>nul
rem --------------------------------------
if "%1"=="" cls&echo.&echo All done!
goto timer

:collect_smx
set INPDIR=%SRC%%LAYOUT%_dual_epbios\%PROJECT%\
set OUTDIR=%DEST%smx_%LAYOUT%_layout\dual_epbios_smx_%YENSLASH%\
md %OUTDIR% >nul 2>nul
if not "%OPTMODE%"=="" rem.>"%OUTDIR%%OPTMODE%"
move %INPDIR%fw\%PROJECT%.pld %OUTDIR% >nul 2>nul
move %INPDIR%fw\recovery.jic %OUTDIR% >nul 2>nul
cd %INPDIR%
set CONFIG=%PROJECT%_512k_single_epbios_%YENSLASH%
copy /Y %CONFIG%.cof %PROJECT%_512k.cof >nul 2>nul
"%QUARTUS_ROOTDIR%\bin\quartus_cpf.exe" -c %PROJECT%_512k.cof >nul 2>nul
del %PROJECT%_512k.cof >nul 2>nul
call 2_sm_finalize.cmd --no-wait
call 3_sm_collect.cmd --no-wait
cd %~dp0
set OUTDIR=%DEST%smx_%LAYOUT%_layout\single_epbios_smx_%YENSLASH%\
md %OUTDIR% >nul 2>nul
if not "%OPTMODE%"=="" rem.>"%OUTDIR%%OPTMODE%"
move %INPDIR%fw\%PROJECT%.pld %OUTDIR% >nul 2>nul
move %INPDIR%fw\recovery.jic %OUTDIR% >nul 2>nul
goto:eof

:err_quartus
if "%1"=="" color f0
echo.&echo Quartus II was not found or unsupported device!
goto timer

:err_msg
if "%1"=="" color f0
echo.&echo '%SRC%' not found!

:timer
if "%1"=="" waitfor /T %TIMEOUT% pause >nul 2>nul

:quit
